Subject: Re: [PATCH] arm64: cpufeature: Fix truncating a feature value

From: Greg KH <[email-masked]>
Date: Fri, 11 Oct 2019 14:13:00 +0200

On Fri, Oct 11, 2019 at 11:31:30AM +0100, Suzuki K Poulose wrote:
> Hi Greg,
> 
> On 11/10/2019 05:55, Greg KH wrote:
> > On Thu, Oct 10, 2019 at 02:19:43PM +0100, Suzuki K Poulose wrote:
> > > A signed feature value is truncated to turn to an unsigned value
> > > causing bad state in the system wide infrastructure. This affects
> > > the discovery of FP/ASIMD support on arm64. Fix this by making sure
> > > we cast it properly.
> > > 
> > > This was inadvertently fixed upstream in v4.6 onwards with the following :
> > > commit 28c5dcb22f90113dea ("arm64: Rename cpuid_feature field extract routines")
> > 
> > What prevents us from just taking that commit instead?  You did not
> > document that here at all, which I thought I asked for.
> 
> Sorry, I missed that part. So, that change introduces helpers to
> extract feature fields based on the sign. And it also depends on
> 
> commit ff96f7bc7bf6 ("arm64: capabilities: Handle sign of the feature bit")
> 
> which introduces "sign" bit for the "capability" list and modifies
> the generic capability->matches() helpers to use the hint to switch to the
> appropriate helpers.

That's ok, does that cause any problems?  We always want the original
patch instead of a one-off patch as that way we do not diverge.

> I could backport parts of the commit 28c5dcb22f90 dropping the bits
> that affect the changes mentioned above.

Please do, that is always prefered as well, but do the first thing above
if at all possible.

> > 
> > Also, you only need 12 digits for a sha1, 28c5dcb22f90 ("arm64: Rename
> > cpuid_feature field extract routines") would be just fine :)
> 
> Yea, I understand. Its simply a pain to count the numbers, so I make sure
> to pickup something that looks larger than the 12 ;-). I will try to stick
> to that :-)

	git show -s --abbrev-commit --abbrev=12 --pretty=format:"%h (\"%s\")%n"
will give you the correct format.  I suggest making it a git alias :)

Or, use:
	[core]
	        abbrev = 12
in your .gitconfig file.

thanks,

greg k-h

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel